/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) ProLogic, Incorporated 2008, 1000 Technology Drive, Fairmont, WV 26554
 * Produced pursuant to U.S. Government sponsorship.
 * 
 * Copyright applies to commercial uses only.   Notwithstanding the above
 * copyright/restriction, the Government possesses DFARS 252.227-7013. 
 * Unlimited Rights if this is technical data and DFARS 252.227-7014. 
 * Unlimited Rights if this is computer software or computer software 
 * documentation.
 * 
 * $Id: $
 *****************************************************************************/
/**
 * @file SubjectTest.h
 * Main header file for the PROJECT_NAME application.
 * 
 * @todo Fix file description.
 */


///////////////////////////////////////////////////////////////////////////////
// pragmas
///////////////////////////////////////////////////////////////////////////////

#pragma once


///////////////////////////////////////////////////////////////////////////////
// includes
///////////////////////////////////////////////////////////////////////////////

#include <cppunit/extensions/HelperMacros.h>


struct CSubjectTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( CSubjectTest );

	CPPUNIT_TEST( TestLess );

	CPPUNIT_TEST( TestGetSet );
	CPPUNIT_TEST( TestAttach );
	CPPUNIT_TEST( TestDetachUnattached );
	CPPUNIT_TEST( TestDetach );
	CPPUNIT_TEST( TestThrowDoesntDisrupt );

	CPPUNIT_TEST( TestVoidAttach );
	CPPUNIT_TEST( TestVoidDetachUnattached );
	CPPUNIT_TEST( TestVoidDetach );
	CPPUNIT_TEST( TestVoidThrowDoesntDisrupt );

	CPPUNIT_TEST( TestRefGetSet );
	CPPUNIT_TEST( TestConstRefGetSet );
	CPPUNIT_TEST( TestRefSetTarget );
	CPPUNIT_TEST( TestRefAttach );
	CPPUNIT_TEST( TestRefDetachUnattached );
	CPPUNIT_TEST( TestRefDetach );
	CPPUNIT_TEST( TestRefThrowDoesntDisrupt );

	CPPUNIT_TEST_SUITE_END();

private:
	void TestLess();

	void TestGetSet();
	void TestAttach();
	void TestDetachUnattached();
	void TestDetach();
	void TestThrowDoesntDisrupt();

	void TestVoidAttach();
	void TestVoidDetachUnattached();
	void TestVoidDetach();
	void TestVoidThrowDoesntDisrupt();

	void TestRefGetSet();
	void TestConstRefGetSet();
	void TestRefSetTarget();
	void TestRefAttach();
	void TestRefDetachUnattached();
	void TestRefDetach();
	void TestRefThrowDoesntDisrupt();
};


