/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) WebSec Corporation
 *
 *****************************************************************************/
/**
 * @file ZeroizeUtils.h
 * Header file for CZeroizeUtils class which provides zeroization utilities.
 */


///////////////////////////////////////////////////////////////////////////////
// pragmas
///////////////////////////////////////////////////////////////////////////////

#pragma once


///////////////////////////////////////////////////////////////////////////////
// includes
///////////////////////////////////////////////////////////////////////////////
#include <stddef.h> //for size_t


/**
 * This provides for zeroization utilities.
 */
class CZeroizeUtils
{
public:
	/**
	 * Constructor
	 */
	CZeroizeUtils();

	/**
	 * Destructor
	 */
	virtual ~CZeroizeUtils();

	/**
	* This will zeroize a range of bytes.
	*
	* @param pcInputBytes - this is the pointer to the bytes to zeroize.
	* @param nInputSize - this is the nuber of bytes to zeroize in the pointer.
	*/
	static void Zeroize(unsigned char* pcInputBytes, size_t nInputSize);
};
